/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEBGPU)

#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "WebGPUCommandEncoder.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSWebGPUCommandEncoder : public JSDOMWrapper<WebGPUCommandEncoder> {
public:
    using Base = JSDOMWrapper<WebGPUCommandEncoder>;
    static JSWebGPUCommandEncoder* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<WebGPUCommandEncoder>&& impl)
    {
        JSWebGPUCommandEncoder* ptr = new (NotNull, JSC::allocateCell<JSWebGPUCommandEncoder>(globalObject->vm().heap)) JSWebGPUCommandEncoder(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static WebGPUCommandEncoder* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
protected:
    JSWebGPUCommandEncoder(JSC::Structure*, JSDOMGlobalObject&, Ref<WebGPUCommandEncoder>&&);

    void finishCreation(JSC::VM&);
};

class JSWebGPUCommandEncoderOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, WebGPUCommandEncoder*)
{
    static NeverDestroyed<JSWebGPUCommandEncoderOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(WebGPUCommandEncoder* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, WebGPUCommandEncoder&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebGPUCommandEncoder* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<WebGPUCommandEncoder>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<WebGPUCommandEncoder>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<WebGPUCommandEncoder> {
    using WrapperClass = JSWebGPUCommandEncoder;
    using ToWrappedReturnType = WebGPUCommandEncoder*;
};
#if ENABLE(WEBGPU)

template<> WebGPUBufferCopyView convertDictionary<WebGPUBufferCopyView>(JSC::JSGlobalObject&, JSC::JSValue);

#endif

#if ENABLE(WEBGPU)

template<> WebGPUTextureCopyView convertDictionary<WebGPUTextureCopyView>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(WEBGPU)
